#include "alternativeimportwidget.h"

AlternativeImportWidget::AlternativeImportWidget(MultiLangImportWidget *parent) :  MultiLangImportWidget(parent)
{
    //desable this stuff!
    langCountSlider->setVisible(false);
    sliderDescr->setVisible(false);
    langCountSlider->setRange(3,3);
    langCountSlider->setValue(3);
    langCountSlider->blockSignals(true);
    onSliderMoved();
    this->setWindowTitle("Import *.CSV from the Erasmus+ Quiz App!");

//    syncComboBoxes();
}
void AlternativeImportWidget::updateLang(QList<languageType> ll){
    langList = ll;
    checkIfImportable();
    wContainer->setEnabled(langList.count()!=0);
    qDebug() << "hi and "<<ll.count();
    if(langList.count()>0){
        infoTxt->setText("You must have at least 3 Languages!");
    }
    else{
        infoTxt->setText("Looks Like your Database does not have any Languages");
    }
    syncComboBoxes();
    for(int i = 0; i < comboList.count();i++){
        updateComboBox((QComboBox*)comboList.at(i));
    }
}
void AlternativeImportWidget::syncComboBoxes()
{
    int count = 3;

    QGridLayout* layout = (QGridLayout*)wContainer->layout();

    if( -(count-comboList.count()) > 0){
        int val = -(count-comboList.count());

        if(val < 0)return;
        for(int i = 0; i < val;i++){
            layout->removeWidget(comboList.last());
            layout->removeWidget(labelList.last());
            delete comboList.last();
            delete labelList.last();
            labelList.removeLast();
            comboList.removeLast();
        }


    }
    else if(comboList.count() - count < 0){
            //add
            int val = -(comboList.count() - count);
            for(int i = 0; i < val;i++){
                QComboBox* box = new QComboBox();
                QLabel*    lab = new QLabel(tr("Lanugage ").append(QString::number(i+1)));
                comboList.append(box);
                labelList.append(lab);
                layout->addWidget(lab,comboList.count()+i,0);
                layout->addWidget(box,comboList.count()+i,1);
                updateComboBox(box);

                connect(box,SIGNAL(currentIndexChanged(int)),this,SLOT(checkIfImportable()));

            }
            for(int i = 0; i < labelList.count();i++){
                QString txt;
                if(i==0)txt = "German-->";
                if(i==1)txt = "English->";
                if(i==2)txt = "Estonia->";
                labelList.at(i)->setText(txt);
            }
        }

}
void AlternativeImportWidget::openAltImportWidget(){
    onNewPath("");

      this->show();this->setFocus();
    for(int i = 0; i < labelList.count();i++){
        QString txt;
        qDebug() << "RUNNED!!!";
        if(i==0)txt = "German-->";
        if(i==1)txt = "English->";
        if(i==2)txt = "Estonia->";
        labelList.at(i)->setText(txt);
    }
}
