#include "modell.h"
#include <QFile>
#include <QDebug>
#define DEBUG
#define PRIMARYKEYTXT " integer  PRIMARY KEY AUTOINCREMENT NOT NULL"
#define SETTRUEWITHINTEGERS false

Modell::Modell(QObject *parent) : QObject(parent)
{
    //if(no Config Data aviable then load std)
    structure = getDefaultSQLStructure();
    database = QSqlDatabase::addDatabase("QSQLITE");
}

void Modell::sendCategorys(){

}
void Modell::sendQuestions(){

}
void Modell::sendAnswersOf(int question_id){

}
bool Modell::isOpen(){
    return database.isOpen();
}
UserDataBase* Modell::getDatabaseReference(){
    return (UserDataBase*)&this->dbSelf;
}
//DENK DRANN VON UNTEN NACH OBEN HIRARCHIE MÄßIG LÖSCHEN!
void Modell::deleteLanguageFromDataBase(languageType* lt){
    if(lt == Q_NULLPTR)return;
    getQuery().exec(QString("DELETE FROM lang where lang_id = ").append(QString::number(lt->getLangId())));
}
void Modell::deleteCategoryFromDataBase(Category* c ){
    if(c == Q_NULLPTR)return;
    QSqlQuery q = getQuery();
    q.exec(QString("DELETE From ").append(structure.category_lang.tableName).
           append(" where ").append(structure.category.collum1).append(" = ").append(QString::number(c->getCategoryId())));
    q.exec(QString("DELETE From ").append(structure.category.tableName).append(" where ").append(structure.category.collum1).append(" = ").append(QString::number(c->getCategoryId())));
}
void Modell::deleteQuestionFromDataBase(Question* c ){
    QSqlQuery q = getQuery();
    q.exec(QString("DELETE From ").append(structure.question_lang.tableName).append(" where ").append(structure.question.tableName).append(" = ").append(QString::number(c->getQuestionid())));
    q.exec(QString("DELETE From ").append(structure.question.tableName).append(" where ").append(structure.question.collum1).append(" = ").append(QString::number(c->getQuestionid())));
}
void Modell::deleteAnswerFromDataBase  (Answer  * a ){
    QSqlQuery q = getQuery();
    /*qDebug() <<*/ (QString("DELETE From ").append(structure.answer.tableName).append(" where ").append(structure.answer.collum1).append(" = ").append(QString::number(a->getAnswer_id())));
    /*qDebug() <<*//*"del Answer txt! = "<<*/ q.exec(QString("DELETE From ").append(structure.answer_lang.tableName).append(" where ").append(structure.answer.collum1).append(" = ").append(QString::number(a->getAnswer_id())));
    /*qDebug() <<" del answer self" <<*/q.exec(QString("DELETE From ").append(structure.answer.tableName).append(" where ").append(structure.answer.collum1).append(" = ").append(QString::number(a->getAnswer_id())));
    q.exec("DELETE from question_answer where answer_id = "+QString::number(a->getAnswer_id()));
}
void Modell::renameLanguageTypeFromDatabase(languageType* lt){
    if(lt == Q_NULLPTR)return;
    QSqlQuery q = getQuery();
    q.exec(QString("Update ").append(structure.lang.tableName).append(" SET ").append(structure.lang.collum2).append(" = '").append(lt->lang).append("' where lang_id = ").append(QString::number(lt->getLangId())).append(""));
    //qDebug() << QString("Update ").append(structure.lang.tableName).append(" SET ").append(structure.lang.collum2).append(" = '").append(lt->lang).append("' where lang_id = ").append(QString::number(lt->getLangId())).append("");
    //q.exec(QString("Update ").append(structure.lang.tableName).append(" SET ").append(structure.lang.collum3).append(" = '").append(lt->langName).append("' where lang_id = ").append(QString::number(lt->getLangId())).append(""));

}
void Modell::renameCategoryFromDatabase(Category* c){
    if(c==Q_NULLPTR)return;
    if(this->dbSelf.languages.count() < c->text.count())return;
    QSqlQuery q = getQuery();

    int category_id = c->getCategoryId();
    /*qDebug() << *//*" gets = "<< c->text.at(0).text;*/
    for(int l = 0; l < c->text.count();l++){
        QString text = "";
        if(c->text.at(l).job == ADD_){
            /*qDebug() << */QString("Insert into ").append(structure.category_lang.tableName).append(" (").append(structure.category_lang.collum1).append(",").append(structure.category_lang.collum2).append(",").append(structure.category_lang.collum3).append(") values(").append(QString::number(c->text.at(l).lang_id)).append(",").append(QString::number(category_id)).append(",'").append(c->text.at(l).text).append("','").append(text).append("')");
            /*qDebug() << */q.exec(QString("Insert into ").append(structure.category_lang.tableName).append(" (").append(structure.category_lang.collum1).append(",").append(structure.category_lang.collum2).append(",").append(structure.category_lang.collum3).append(") values(").append(QString::number(c->text.at(l).lang_id)).append(",").append(QString::number(category_id)).append(",'").append(c->text.at(l).text).append("')"));
        }
    }
    for(int l = 0; l < c->text.count();l++){
        /*qDebug() << "hi " <<*/QString("Update ").append(structure.category_lang.tableName).append(" SET category_text = '").append(c->text.at(l).text).append("'").append(" where category_id = ").append(QString::number(category_id)).append(" AND lang_id = ").append(QString::number(c->text.at(l).lang_id));
        /*qDebug() << "hi 2" <<*/q.exec(QString("Update ").append(structure.category_lang.tableName).append(" SET category_text = '").append(c->text.at(l).text).append("'").append(" where ").append(structure.category.collum1).append(" = ").append(QString::number(category_id)).append(" AND ").append(structure.lang.collum1).append(" = ").append(QString::number(c->text.at(l).lang_id)));
    }
}
void Modell::renameQuestionFromDatabase(Question* c){
    if(c==Q_NULLPTR)return;
    QSqlQuery q = getQuery();
    int question_id = c->getQuestionid();

    for(int l = 0; l < c->text.count();l++){
        if(c->text.at(l).job != ADD_)continue;
        QString txt = c->text.at(l).text;
        /*qDebug() <<*/ (QString("Insert into ").append(structure.question_lang.tableName).append(" (").append(structure.question_lang.collum1).append(",").append(structure.question_lang.collum2).append(",").append(structure.question_lang.collum3).append(") values(").append(QString::number(question_id)).append(",").append(QString::number(c->text.at(l).lang_id)).append(",'").append(txt).append("')"));
        /*qDebug() << "add Q txt"<<*/ q.exec(QString("Insert into ").append(structure.question_lang.tableName).append(" (").append(structure.question_lang.collum1).append(",").append(structure.question_lang.collum2).append(",").append(structure.question_lang.collum3).append(") values(").append(QString::number(question_id)).append(",").append(QString::number(c->text.at(l).lang_id)).append(",'").append(txt).append("')"));
    }
    for(int l = 0; l < c->text.count();l++){
        q.exec(QString("Update ").append(structure.question_lang.tableName).append(" SET question_text = '").append(c->text.at(l).text).append("'").append(" where question_id = ").append(QString::number(question_id)).append(" AND lang_id = ").append(QString::number(c->text.at(l).lang_id)));
    }
}
void Modell::renameAnswerFromDatabase(Answer* a){
    if(a==Q_NULLPTR)return;
    QSqlQuery q = getQuery();
    int answer_id = a->getAnswer_id();
    for(int l = 0; l < a->text.count();l++){
        if(a->text.count() == a->explanation.count())
            if(a->text.at(l).job == ADD_||a->explanation.at(l).job == ADD_){
                qDebug() << "add txt to Answer"<<q.exec(QString("Insert into ").append(structure.answer_lang.tableName).append(" (answer_id,lang_id,answer_text,explanation_text) values(").append(QString::number(answer_id)).append(",").append(QString::number(a->text.at(l).lang_id)).append(",'").append(a->text.at(l).text).append("','").append(a->explanation.at(l).text).append("')"));

            }
    }
    for(int l = 0; l < a->text.count();l++){
        q.exec(QString("Update ").append(structure.answer_lang.tableName).append(" SET answer_text = '").append(a->text.at(l).text).append("' where answer_id = ").append(QString::number(answer_id)).append(" AND lang_id = ").append(QString::number(a->text.at(l).lang_id)));
    }
    for(int l = 0; l < a->explanation.count();l++){
        q.exec(QString("Update ").append(structure.answer_lang.tableName).append(" SET explanation_text = '").append(a->explanation.at(l).text).append("' where answer_id = ").append(QString::number(answer_id)).append(" AND lang_id = ").append(QString::number(a->explanation.at(l).lang_id)));
    }
    // qDebug() << "txt "<<QString("UPDATE ").append(structure.question_answer.tableName).append(" SET is_True = ").append(QLocale::system().toString(a->isCorrect())).append(" WHERE answer_id = ").append(QString::number(answer_id)).append(" AND question_id = ").append(QString::number(a->getQuestionId()));
    if(SETTRUEWITHINTEGERS){
        qDebug() << "isTrue!! !" << q.exec(QString("UPDATE ").append(structure.question_answer.tableName).append(" SET is_True = ").append(QLocale::system().toString(a->isCorrect())).append(" WHERE answer_id = ").append(QString::number(answer_id)).append(" AND question_id = ").append(QString::number(a->getQuestionId())));
    }
    else{
        QString istrue = "'true'";
        if(!a->isCorrect())istrue="'false'";
        qDebug() << "isTrue!! !" << q.exec(QString("UPDATE ").append(structure.question_answer.tableName).append(" SET is_True = ").append(istrue).append(" WHERE answer_id = ").append(QString::number(answer_id)).append(" AND question_id = ").append(QString::number(a->getQuestionId())));
    }
}
void Modell::addLanguageTypeFromDatabase(languageType* lt){
    if(lt == Q_NULLPTR)return;
    getQuery().exec(QString("INSERT INTO ").append(structure.lang.tableName).append(" (country_code) values ('").append(lt->lang).append("')"));
}
void Modell::addCategoryToDatabase(Category* c){
    QSqlQuery q = getQuery();
    q.exec(QString("INSERT INTO ").append(structure.category.tableName).append(" values(NULL)"));
    q.exec("select last_insert_rowid()");
    if(!q.next()){
        qDebug() << "get last id failed";return;//did it work?
    }
    int new_cId = q.value(0).toInt();
    for(int l = 0;l < c->text.count();l++){

        QString text="";
        text = c->text.at(l).text;
        q.exec(QString("Insert into ").append(structure.category_lang.tableName).append(" (lang_id,category_id,category_text) values(").append(QString::number(c->text.at(l).lang_id)).append(",").append(QString::number(new_cId)).append(",'").append(text).append("')"));
        //qDebug() << "add new Category text is = "<<QString("Insert into ").append(structure.category.tableName).append(" (lang_id,category_id,category_name,category_text) values(").append(QString::number(c->name.at(l).lang_id)).append(",").append(QString::number(new_cId)).append(",'").append(c->name.at(l).text).append("','").append(text).append("')");
    }
    c->setCategoryId(new_cId);

    // qDebug() << new_cId << " = new id";

}
void Modell::addQuestionToDatabase(Question* q){
    //qDebug() << "QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ";
    if(q->getParent() == Q_NULLPTR){
        qDebug() << " kein parent :/ ";
        return;
    }

    QSqlQuery qu = getQuery();
    //qDebug() << "id is = "<< q->getCategoryid();
    qu.exec(QString("INSERT INTO ").append(structure.question.tableName).append("(category_id) values(").append(QString::number(q->getCategoryid())).append(")"));
    qu.exec("select last_insert_rowid()");
    if(!qu.next()){
        qDebug() << "get last id failed";return;//did it work?
    }

    int id = qu.value(0).toInt();
    qDebug() << "last q id = " << id;
    for(int l = 0;l < q->text.count();l++){
       // qDebug() << (QString("Insert into ").append(structure.question_lang.tableName).append(" (question_id,lang_id,question_text) values(").append(QString::number(q->text.at(l).lang_id)).append(",").append(QString::number(id)).append(",'").append(q->text.at(l).text).append("')"));
        qDebug() << "add questiontxt" << qu.exec(QString("Insert into ").append(structure.question_lang.tableName).append(" (question_id,lang_id,question_text) values(").append(QString::number(id)).append(",").append(QString::number(q->text.at(l).lang_id)).append(",'").append(q->text.at(l).text).append("')"));
    }
    q->setQuestionId(id);
    q->updateIds();
    // qDebug() << "done id "<<id;
}
void Modell::addAnswerToDatabase(Answer* a){


    QSqlQuery qu = getQuery();
    qu.exec(QString("INSERT INTO ").append(structure.answer.tableName).append(" values(NULL)"));
    qu.exec("select last_insert_rowid()");
    if(!qu.next()){
        qDebug() << "get last id failed";return;//did it work?
    }
    int id = qu.value(0).toInt();
    qDebug() << "1337 "<<id;



    if(SETTRUEWITHINTEGERS){
       qu.exec(QString("insert into ").append(structure.question_answer.tableName).append(" (question_id,answer_id,is_True) values(").append(QString::number(a->getQuestionId())).append(",").append(QString::number(id)).append(",").append(QLocale::system().toString(a->isCorrect())).append(")"));
    }
    else{
        QString istrue = "'true'";
        if(!a->isCorrect())istrue="'false'";
        qu.exec(QString("insert into ").append(structure.question_answer.tableName).append(" (question_id,answer_id,is_True) values(").append(QString::number(a->getQuestionId())).append(",").append(QString::number(id)).append(",").append(istrue).append(")"));
    }


    // qDebug() << QString("insert into ").append(structure.question_answer.tableName).append(" (question_id,answer_id,is_True) values(").append(QString::number(a->getQuestionId())).append(",").append(QString::number(id)).append(",").append(QLocale::system().toString(a->isCorrect())).append(")");
    for(int l = 0;l < a->text.count();l++){
        qDebug() << a->text.count()<<"fail!"<<l;


        QString sampleText = "SAMPLE TEXT";
        if(a->explanation.count() > l)
            sampleText = a->explanation.at(l).text;
        qDebug() << qu.exec(QString("Insert into ").append(structure.answer_lang.tableName).append(" (answer_id,lang_id,answer_text,explanation_text) values(").append(QString::number(id)).append(",").append(QString::number(a->text.at(l).lang_id)).append(",'").append(a->text.at(l).text).append("','").append(sampleText).append("')"));
    }
    a->setAnswerId(id);
}

void Modell::removeAllTextFromCategory(int languageId){
    QSqlQuery q = getQuery();
    q.exec(QString("DELETE FROM ").append(structure.category_lang.tableName).append(" where lang_id = ").append(QString::number(languageId)));
}
void Modell::removeAllTextFromQuestion(int languageId){
    QSqlQuery q = getQuery();
    q.exec(QString("DELETE FROM ").append(structure.question_lang.tableName).append(" where lang_id = ").append(QString::number(languageId)));
}
void Modell::removeAllTextFromAnswer(int languageId){
    QSqlQuery q = getQuery();
    q.exec(QString("DELETE FROM ").append(structure.answer_lang.tableName).append(" where lang_id = ").append(QString::number(languageId)));
}
void Modell::closeDatabase(){
    database.close();
    dbSelf = UserDataBase();
    emit dataBaseClosed();
}
void Modell::saveChangesToDataBase(){
    //qDebug() << "-------SAVE------";
    dbSelf.printAll();
    checkForBadSymbols(&dbSelf.categorys);
    for(int l = 0; l < dbSelf.languages.count();l++){
        languageType* lt = (languageType*)&dbSelf.languages.at(l);
        if(lt->job == DELETE_){
            int l_Id = lt->getLangId();
            removeAllTextFromCategory(l_Id);
            removeAllTextFromQuestion(l_Id);
            removeAllTextFromAnswer(l_Id);
            deleteLanguageFromDataBase(lt);
        }
        else if(lt->job == ADD_)
            addLanguageTypeFromDatabase(lt);
        else if(lt->job == EDIT)
            renameLanguageTypeFromDatabase(lt);

    }

    for(int c = 0; c < dbSelf.categorys.count();c++)
    {
        bool deleteCAT = false;
        Category* cat = (Category*)&dbSelf.categorys.at(c);
        if(cat->job == DELETE_)
            deleteCAT = true;
        for(int q = 0; q < cat->questions.count();q++){
            bool deleteQuest = false;
            Question* quest = (Question*)&cat->questions.at(q);
            if(quest->job == DELETE_)
                deleteQuest = true;
            for(int a = 0; a < quest->answers.count();a++){
                Answer* aa = (Answer*)&quest->answers.at(a);
                if(deleteCAT||deleteQuest||aa->job==DELETE_)
                    deleteAnswerFromDataBase(aa);
            }
            if(deleteQuest||deleteCAT)
                this->deleteQuestionFromDataBase(quest);
        }
        if(deleteCAT)
            deleteCategoryFromDataBase(cat);
    }
    for(int c = 0; c < dbSelf.categorys.count();c++)
    {
        Category* cat = (Category*)&dbSelf.categorys.at(c);
        if(cat->job == EDIT)
            renameCategoryFromDatabase(cat);
        if(cat->job == ADD_)
            addCategoryToDatabase(cat);

        for(int q = 0; q < cat->questions.count();q++){

            Question* quest = (Question*)&cat->questions.at(q);
            if(quest->getParent()== Q_NULLPTR)
                quest->setParentAddress((Category*)&cat);
            if(quest->job == EDIT)
                renameQuestionFromDatabase(quest);
            if(quest->job == ADD_){
                addQuestionToDatabase(quest);

            }
            for(int a = 0; a < quest->answers.count();a++){
                Answer* aa = (Answer*)&quest->answers.at(a);

                if(aa->job == EDIT)
                    renameAnswerFromDatabase(aa);
                if(aa->job == ADD_)
                    addAnswerToDatabase(aa);
            }
        }
    }

    extractDataFromDatabase();

}
void Modell::extractDataFromDatabase(){
    dbSelf.languages.clear();

    QList<Category> categorys;
    QSqlQuery q = getQuery();


    q.exec(QString("Select * from ").append(structure.lang.tableName).append(""));
    while(q.next()){
        dbSelf.languages.append(languageType(q.value("lang_id").toInt(),q.value("country_code").toString()));
    }
    for(int l = 0; l < dbSelf.languages.count();l++){
        qDebug() << "lang kürzel = "<<dbSelf.languages.at(l).lang;
        qDebug() << "lang id === "<<dbSelf.languages.at(l).getLangId();
    }
    q.exec(QString(" Select * from ").append(structure.category.tableName).append(""));
    while(q.next()){
        categorys.append(Category(q.value("category_id").toInt()));
    }

    for(int c = 0; c < categorys.count();c++){
        q.exec(QString("Select * from ").append(structure.question.tableName).append(" where category_id = ").append(QString::number(categorys.at(c).getCategoryId())));
        while(q.next()){
            Category* cc = (Category*)(&categorys.at(c));
            Question quest(q.value("question_id").toInt(),cc);
            cc->addOneQuestion(quest);
        }

        for(int i = 0; i < categorys.at(c).questions.count();i++){
            q.exec(QString("Select * from ").append(structure.question_answer.tableName).append(" where question_id = ").append(QString::number(categorys.at(c).questions.at(i).getQuestionid())));
            Question* cc = (Question*)(&categorys.at(c).questions.at(i));
            while(q.next()){
                Answer aa = Answer(q.value("answer_id").toInt(),(Question*)&categorys.at(c).questions.at(i));
                aa.setCorrect(q.value("is_True").toBool());
                cc->addOneAnswer(aa);
            }
        }

    }
    qDebug() <<"getting text out of database";
    //getting text out of database
    for(int l = 0; l < dbSelf.languages.count();l++){
        for(int c = 0; c < categorys.count();c++){
            //qDebug() << "getting the lang " << QString("Select * from ").append(structure.category_lang.tableName).append(" where category_id = ").append(QString::number(categorys.at(c).getCategoryId())).append(" AND lang_id = ").append(QString::number(dbSelf.languages.at(l).getLangId()));
            q.exec(QString("Select * from ").append(structure.category_lang.tableName).append(" where category_id = ").append(QString::number(categorys.at(c).getCategoryId())).append(" AND lang_id = ").append(QString::number(dbSelf.languages.at(l).getLangId())));
            Category* cc = (Category*)&categorys.at(c);

            while(q.next()){
                cc->text.append(Lang_Text(l,q.value("category_text").toString()));
                cc->text.last().lang_id = dbSelf.languages.at(l).getLangId();
                if(l == 1)
                    qDebug() << "found!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
            }

            for(int qu = 0; qu < cc->questions.count();qu++){
                qDebug() << "wile3";
                Question* qq = (Question*)&cc->questions.at(qu);

                qDebug() << "wile4";
                q.exec(QString("Select * from ").append(structure.question_lang.tableName).append(" where question_id = ").append(QString::number(cc->questions.at(qu).getQuestionid())).append(" AND lang_id = ").append(QString::number(dbSelf.languages.at(l).getLangId())));




                while(q.next()){
                    qq->text.append(Lang_Text(l,q.value("question_text").toString()));
                    qq->text.last().lang_id = dbSelf.languages.at(l).getLangId();

                }


                for(int a = 0; a < categorys.at(c).questions.at(qu).answers.count();a++){
                    q.exec(QString("Select * from ").append(structure.answer_lang.tableName).append(" where answer_id = ").append(QString::number(categorys.at(c).questions.at(qu).answers.at(a).getAnswer_id())).append(" AND lang_id = ").append(QString::number(dbSelf.languages.at(l).getLangId())));
                    Answer* aa = (Answer*)&qq->answers.at(a);
                    while(q.next()){
                        aa->text.append(Lang_Text(l,q.value("answer_text").toString()));
                        aa->text.last().lang_id = dbSelf.languages.at(l).getLangId();
                        aa->explanation.append(Lang_Text(l,q.value("explanation_text").toString()));
                        aa->explanation.last().lang_id = dbSelf.languages.at(l).getLangId();
                    }
                }
            }
        }
    }
    qDebug() << "next";
    for(int c = 0; c < categorys.count();c++){
        Category* cc = (Category*)&categorys.at(c);
        qDebug() << "next"<<cc;


        cc->text = reOrderTextByLangId((QList<Lang_Text>*)&cc->text,dbSelf.languages);

        for(int qu = 0; qu < categorys.at(c).questions.count();qu++){
            Question* qq = (Question*)&cc->questions.at(qu);
            qq->text = reOrderTextByLangId((QList<Lang_Text>*)&qq->text,dbSelf.languages);

            for(int a = 0; a < categorys.at(c).questions.at(qu).answers.count();a++){
                Answer* aa = (Answer*)&qq->answers.at(a);
                aa->text = reOrderTextByLangId((QList<Lang_Text>*)&aa->text,dbSelf.languages);
            }
        }
    }

    dbSelf.categorys = categorys;
    qDebug() << "lelz";
    dbSelf.printAll();
}
void Modell::openDatabase(QString path){
    qDebug() << "path is "<<path;
    database.close();
    dbSelf = UserDataBase();
    bool exists = true;
    exists = QFile::exists(path);
    database.setDatabaseName(path);
    database.open();
    if(!exists){
        createDataBase();
        fillDataBaseWithStdLangs();
    }
    extractDataFromDatabase();


    //done
    if(database.isOpen())
        emit dataBaseOpened();

}
QSqlQuery Modell::getQuery(){
    return QSqlQuery(database);
}

void Modell::createDataBase(){
    qDebug() << "17";
    QString lang            = QString("CREATE TABLE ").append(structure.lang.tableName).append(" (lang_id integer  PRIMARY KEY AUTOINCREMENT,country_code varchar(50)  NOT NULL)");
    QString category        = QString("CREATE TABLE ").append(structure.category.tableName).append(" (category_id integer  PRIMARY KEY AUTOINCREMENT)");
    QString question        = QString("CREATE TABLE ").append(structure.question.tableName).append("(question_id integer  PRIMARY KEY AUTOINCREMENT,category_id integer  NOT NULL)");
    QString answer          = QString("CREATE TABLE ").append(structure.answer.tableName).append(" (answer_id integer  PRIMARY KEY AUTOINCREMENT NOT NULL )");
    QString quest_has_answ  = QString("CREATE TABLE ").append(structure.question_answer.tableName).append(" (question_id integer NOT NULL,answer_id integer NOT NULL,is_True BOOLEAN NOT NULL)");
    QString lang_has_answ   = QString("CREATE TABLE ").append(structure.answer_lang.tableName).append(" (answer_id integer NOT NULL,lang_id integer NOT NULL,answer_text varchar(250) NOT NULL,explanation_text varchar(250) NOT NULL)");
    QString lang_has_quest  = QString("CREATE TABLE ").append(structure.question_lang.tableName).append(" (question_id integer NOT NULL,lang_id integer NOT NULL,question_text varchar(250) NOT NULL)");
    QString lang_has_cat    = QString("CREATE TABLE ").append(structure.category_lang.tableName).append(" (category_id integer NOT NULL,lang_id integer NOT NULL,category_text varchar(250) NOT NULL)");



    QSqlQuery q     = getQuery();//lets getten die Query, yeah!
    bool langSelf   = q.exec(lang);
    bool catSelf    = q.exec(category);
    bool questSelf  = q.exec(question);
    bool answerSelf = q.exec(answer);
    bool qHasAnsw   = q.exec(quest_has_answ);
    bool lHasAnsw   = q.exec(lang_has_answ);
    bool lHasQuest  = q.exec(lang_has_quest);
    bool lHasCat    = q.exec(lang_has_cat);
    QString appTable1 = "create table settings(current_country_code varchar(3) not null,current_lang_id integer not null)";
    QString appTable2 = "insert into settings values('DE',1);";
    QString appTable3 = "create table quiz_settings_current_category_id(current_category_id integer not null)";
    QString appTable4 = "create table quiz_settings(question_number integer not null,time_per_question integer not null);";
    q.exec(appTable1);
    q.exec(appTable2);
    q.exec(appTable3);
    q.exec(appTable4);
#ifdef DEBUG
    qDebug() << "---------------<< TABELLEN >>----------------";
    qDebug() << " lang      Tabelle wurde erstellt = "<<langSelf;
    qDebug() << " category  Tabelle wurde erstellt = "<<catSelf;
    qDebug() << " question  Tabelle wurde erstellt = "<<questSelf;
    qDebug() << " answer    Tabelle wurde erstellt = "<<answerSelf;
    qDebug() << " qHasAnsw  Tabelle wurde erstellt = "<<qHasAnsw;
    qDebug() << " lHasAnsw  Tabelle wurde erstellt = "<<lHasAnsw;
    qDebug() << " lHasQuest Tabelle wurde erstellt = "<<lHasQuest;
    qDebug() << " lHasCat   Tabelle wurde erstellt = "<<lHasCat;
    qDebug() << "---------------------------------------------";
#endif



}
void Modell::fillDataBaseWithStdLangs(){
    QSqlQuery q = getQuery();
    /*qDebug() <<*/ q.exec("INSERT INTO lang (country_code) values ('DE')");
    /*qDebug() <<*/ q.exec("INSERT INTO lang (country_code) values ('EN')");
    /*qDebug() << */q.exec("INSERT INTO lang (country_code) values ('EE')");
}

void Modell::exportDataBaseAsCSV(QString path)
{
    if(!path.contains(".csv")||!path.contains(".CSV"))
        path.append(".csv");


    QFile f;
    f.setFileName(path);
    if(!f.open(QIODevice::ReadWrite))return;
    if( !database.isOpen())return;
    QList<QStringList> x ;x.append(getSampleCSVRow(dbSelf.languages.count()));

    int xOffset = 12;

    //content to 2D List
    for(int l = 0; l < dbSelf.languages.count();l++){
        int lID = dbSelf.languages.at(l).getLangId();
        int gO = xOffset*l;//X offset berechnet
        int curEntry = 1;
        for(int c = 0; c < dbSelf.categorys.count();c++){

            for(int q = 0; q < dbSelf.categorys.at(c).questions.count();q++){
                QStringList sL;
                if(l ==0 || x.count() >= curEntry){
                    //placeHolder ! ;D
                }
                if(l > 0)
                {
                    if(curEntry < x.count())
                        sL = x.at(curEntry);
                }
                //lang id
                sL.append(dbSelf.languages.at(l).lang);
                //category
                sL.append(getTextWithLangId(&dbSelf.categorys.at(c).text,lID));
                //question!
                Question* qq = (Question*)&dbSelf.categorys.at(c).questions.at(q);
                sL.append(getTextWithLangId(&qq->text,lID));
                //answers
                for(int b = 0; b < qq->answers.count();b++){
                    if(qq->answers.at(b).isCorrect()){
                        sL.append(getTextWithLangId(&qq->answers.at(b).text,lID));
                        sL.append(getTextWithLangId(&qq->answers.at(b).explanation,lID));
                    }
                }
                for(int a = 0; a < qq->answers.count();a++){
                    if(!qq->answers.at(a).isCorrect()){
                        sL.append(getTextWithLangId(&qq->answers.at(a).text,lID));
                        sL.append(getTextWithLangId(&qq->answers.at(a).explanation,lID));
                    }
                }
                sL.append("||||||||||||");
                if(l == 0 || curEntry >= x.count()){

                    if(l != 0 && curEntry >= x.count()){
                        QStringList lle;
                        for(int i = 0; i < gO;i++){
                            lle.append("SAMPLE TEXT");
                        }
                        sL = lle << sL;
                    }
                    x.append(sL);
                }
                else
                    x.replace(curEntry,sL);
                curEntry++;
            }

        }
    }
    //toString!
    QString finString;
    for(int y = 0; y < x.count();y++){
        for(int i = 0; i < x.at(y).count();i++){
            finString.append(x.at(y).at(i));
            if(i != x.at(y).count()-1)
                finString.append(";");
        }
        finString.append("\r\n");
    }
    f.remove();

    f.open(QIODevice::ReadWrite);//remove calls .close()!
    f.write(finString.toLatin1());
    f.close();
}
